--macroScript GrabViewport category:"Tools" tooltip:"Motion Grab Viewport"
(




function MakeNumber nr = (
	
	local sign = "";
	if nr < 0 then sign = "-";
	nr = sqrt(nr * nr) as integer;
	-- 001 , 011, 111
	
	local n00;
	
	if nr < 10 then n00 = "0000";
	else ( 
			if nr < 100 then n00 = "000";
			else ( 
				if nr < 1000 then n00 = "00";
					else ( 
						if nr < 10000 then n00 = "0";
					)
			)
	)
	if nr as integer > 9999 then n00 = "";
		
	return (sign + n00 + nr as string);
	
)










rollout roGrabViewport "MVC" width:320 height:168
(
	button btrefresh "refresh" pos:[16,72] width:120 height:22 

	button btnRender "Render" pos:[8,134] width:304 height:23

	spinner spnWidth "w" pos:[32,28] width:100 height:16 range:[1,10000,800]
	spinner spnHeight "h" pos:[32,52] width:100 height:16 enabled:false range:[1,10000,600]

	
	spinner spnFrStart "from" pos:[182,28] width:110 height:16 range:[-10000,10000,1] type:#integer scale:1
	spinner spnFrEnd "to" pos:[192,52] width:100 height:16 range:[-10000,10000,1] type:#integer scale:1
	
	edittext edtDir "Save to" pos:[16,110] width:270 height:20
	button btnGetDir "..." pos:[288,110] width:26 height:22
	
		
	groupBox grp1 "Resolution" pos:[8,8] width:136 height:96
	groupBox grp2 "Duration" pos:[160,8] width:144 height:72
		
		
	on roGrabViewport open do
	(
			spnWidth.value = gw.getWinSizeX() as float
			spnHeight.value = gw.getWinSizeY() as float
			global Ratio = spnWidth.value/spnHeight.value
			format "Ratio: % \n" Ratio;
	)
	on btrefresh pressed do
	(
		
		global Ratio = gw.getWinSizeX() as float / gw.getWinSizeY() as float ;
		spnHeight.value = spnWidth.value / Ratio;
		
		--print (gw.getWinSizeX());
		--print (gw.getWinSizeY());
		format "Ratio: % \n" Ratio;
		
	)
	on btnRender pressed do
	(
			---------------------------------------------------------------------
			--GRABVIEWPORT MACROSCRIPT
			--by Borislav Petrov
			--Edited: by Leslie Van den Broeck
			-- 2nd Edit by Till 'rollin' Maginot
			---------------------------------------------------------------------
			--Snapshot Active Viewport to Bitmap
			---------------------------------------------------------------------
			--
			--Init Variables
			
			local grab_bmp --bitmap to put the snapshot into
			local bmp_name --name of the bitmap to save
			local get_viewport_name --viewport name
			local gac,gct,mfn --variables to hold ActiveCamera, CurrentTime, MaxFileName
			
			local frameStart = spnFrStart.value; -- start frame number
			local frameEnd = spnFrEnd.value; -- end frame number
				
				
				
				
				
			-- Prepare Render
			grab_width = gw.getWinSizeX() -- normal screen size
			grab_Height = gw.getWinSizeY()
			
			width = spnWidth.value -- render screen size
			height = spnHeight.value
			gw.setPos 0 0 Width Height -- set viewport position and size
			completeredraw()
			
			
			
			
			
			
			
			
			
			
			-- Build filename basics
			get_fname = edtDir.text; -- get user set output dir + file name + extention
			
			local fpathA = filterString get_fname "\\";
			--print fpathA;
			
			local fpath = "";
			for i=1 to fpathA.count - 1 do(
				fpath = fpath + fpathA[i] + "\\";
			)
		
			local fnameL = fpathA[fpathA.count];
			--print fpath;
			--print fnameL;
			
			local fnameA = filterString fnameL ".";
			--print fnameA;
			local fname = "";
			for i=1 to fnameA.count - 1 do (
				if i > 1 then (fname = fname + ".";)
				fname = fname + fnameA[i];
				
			)
			
			fext = "." + fnameA[fnameA.count];
			--print fname;
			--print fext;
			
			
			get_viewport_name = viewport.GetType() --get viewport name
			gvn = get_viewport_name as string --convert viewport name to string
			gvn = substring gvn 6 (gvn.count-5) --cut the string
			
			if gvn == "camera" then (--if the remaining string is "camera"
				gac = getActiveCamera() --get the camera
				gvn = gac.name --get the name of the camera
			)
			
			mfn = MaxFileName --get max file name
			
			if mfn == "" then  ( --if there is no name
				mfn = "Untitled"; --use "Untitled"
			)
			else (
				mfn = getFileNameFile mfn; --use the file name without .MAX extension
			)
			
			
			
			
			
			
			
			-- Save Image sequence
			for i=frameStart to frameEnd  do (
				
				-- move time slider
				SliderTime = (i as string + "f") as time;
				gct = MakeNumber i; --get current frame time
				
				-- render 
				grab_bmp = gw.getViewportDib() --get the viewport bitmap into variable
				
				-- build final filename
				bmp_name = fpath + fname + "_"+ mfn +"_" +gvn + "_" + gct + fext; --build the output file name
				format "final filename = % \n" bmp_name;
				
				-- save image
				if bmp_name != undefined then (--if user has confirmed / entered a valid name
					grab_bmp.filename = bmp_name --set output name to the one entered in the save file dialog
					save grab_bmp --save the bitmap
					completeredraw()
					--display grab_bmp --display the bitmap in a VFB
				)
				
				
			)
			
			
			
			gw.setPos 0 0 grab_width grab_height -- set viewport back to normal size
			completeredraw()
			
		)
	on spnWidth changed val do
	(
		format("Height: "+heighttest as String+"\n")	
		spnHeight.value = spnWidth.value/Ratio		
		)
	on btnGetDir pressed do
	(
			local tmp = getSaveFileName caption:"Render to:" filename:"Undefined" types:"BMP(*.bmp)|*.bmp|JPG(*.jpg)|*.jpg|TGA(*.tga)|*.tga|TIFF(*.tif)|*.tif|" ;
			if tmp != undefined then edtDir.text = tmp as string;
		)
)







    on Execute do
    (
        MyRolloutFloater = NewRolloutFloater "MotionViewportCapture v0.1" 350 200 10 100
        addRollout roGrabViewport MyRolloutFloater 
    )
)--end of script



